#include "../httpsd.h"
#include "stdsoap2.h"

#define MAX_RANGES 16

class HTTP_ServiceAdv:public HTTP_Service {
 protected:
  HTTPS_Connector *c;
  // HTTP Header
  uint64_t range_start[MAX_RANGES];
  uint64_t range_end[MAX_RANGES];
  uint64_t entity_range_start;
  uint64_t entity_range_end;
  uint64_t entity_size;
  int nranges;
  bool range_passed;
  bool failure_parsing;
  uint64_t length;
  bool length_passed;
  bool entity_range_passed;
  bool entity_size_passed;
  bool unsupported_option_passed;
  // SOAP
  bool ignore_soap_output;
  struct soap sp;
  char soap_fbuf[1024];
  int soap_fbuf_n;
 public:
  HTTP_ServiceAdv(HTTPS_Connector *c_):c(c_),soap_fbuf_n(0) { };
  virtual ~HTTP_ServiceAdv(void) { };
  HTTP_Error parse_header(int &keep_alive);
  HTTP_Error send_header(int &keep_alive,int code = 200);
  HTTP_Error send_header(int &keep_alive,uint64_t start,uint64_t end,bool partial,uint64_t full_size,time_t expires = (time_t)(-1),time_t last_modified = (time_t)(-1));
  static int soap_fsend(struct soap *sp, const char* buf, size_t l);
  int soap_flush(void);
  static size_t soap_frecv(struct soap* sp, char* buf, size_t l);
  static int soap_fopen(struct soap*, const char*, const char*, int);
  static int soap_fclose(struct soap*);
  static int soap_parse(struct soap *sp);
  void soap_init(void);
  void soap_deinit(void);
  HTTP_Error soap_post(const char* uri,int &keep_alive);
  virtual void soap_methods(void);
};

